package application;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.circuitbreaker.EnableCircuitBreaker;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.ribbon.RibbonClient;

import application.ribbon.RibbonConfigurator;
 
@SpringBootApplication
@EnableDiscoveryClient
@RibbonClient (name="ribbonCesta", configuration={RibbonConfigurator.class})
@EnableCircuitBreaker
public class MainApp {
	public static void main(String[] args) {
		SpringApplication.run(MainApp.class, args);
	}
}

							 